#!/bin/sh

#Usage: sysak fanotifytrace [options] [args]
#Options:
#    --syscallid/-i		specify the syscallid,default is fanotify_init id
#    --help/-h			help info
#example: sysak fanotifytrace #trace fanotify_init
#Options:
#    --syscallid/-i		specify the syscallid,default is fanotify_init id
#    --help/-h			help info
#example: sysak fanotifytrace #trace fanotify_init

temp_log_path="fanotifytrace_tmp.log"
fanotify_init_log="/var/log/sysak/fanotifytrace/fanotify_init.log"

function clean() {
    rm $temp_log_path
    rm $test_file
}

function handle_failed() {
    echo "Test fanotifytrace failed." 
    clean
    exit 1
}

function test_help() {
    sysak  -g fanotifytrace -h > $temp_log_path 2>&1 && cat $temp_log_path | grep "Usage: sysak fanotifytrace" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test fanotifytrace helpinfo success."
    fi
}

function test_fanotifytrace() {
    sysak -g fanotifytrace fanotify_init &
    killall sysak
    cat $fanotify_init_log |grep -E "Syscall Number|Name"
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sysak fanotifytrace fanotify_init success."
    fi
}

function main() {
    test_help
    test_fanotifytrace
    clean
}

main
