#!/bin/sh

#Usage: sysak fanotifywait [options] [args]
#Options:
#    -s		specify how long to run, default= 60s
#    -f		specify monitor file or dir
#    -h		help info
#example:
#sysak fanotifywait -f ./test.txt -s 10  #monitor file
#sysak fanotifywait -f ./test -s 10  #monitor file

temp_log_path="fanotifywait_tmp.log"
fanotifywait_log="/var/log/sysak/fanotifywait/fanotifywait.log"

function clean() {
    rm $temp_log_path
    rm $fanotifywait_log
}

function handle_failed() {
    echo "Test fanotifywait failed." 
    clean
    exit 1
}

function test_help() {
    sysak fanotifytrace -h > $temp_log_path 2>&1 && cat $temp_log_path | grep "Usage: sysak fanotifywait" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test fanotifywait helpinfo success."
    fi
}

function test_fanotifywait() {
    mkdir fanotifywait_test
    sysak fanotifywait -f ./fanotifywait_test -s 10 &
    touch fanotifywait_test/test.txt
    sleep 10
    rm -rf fanotifywait_test
    cat $fanotifywait_log |grep "OPEN "
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sysak fanotifywait success."
    fi
}

function main() {
    test_help
    test_fanotifywait
    clean
}

main
