temp_log="temp.log"


function reset()
{
    rm -rf $temp_log
}

function test_h() {
    reset
    sysak -g cpuirq -h > $temp_log 2>&1
    times=`cat $temp_log | grep "sysak cpuirq: show irq information" | wc -l`
    if test $times -eq 1
    then
        echo "Test -h success"
    else
        echo "Test -h failed"
        exit 1
    fi
}

function test_c() {
    reset
    sysak -g cpuirq -c 0 > $temp_log 2>&1
    times=`cat $temp_log | grep maxcpu | wc -l`
    if test $times -eq 1
    then
        echo "Test -c success"
    else
        echo "Test -c failed"
        exit 1
    fi
}

function test_i() {
    reset
    sysak -g cpuirq -i 1 > $temp_log 2>&1
    times=`cat $temp_log | wc -l`
    if test $times -eq 0
    then
        echo "Test -i success"
    else
        echo "Test -i failed"
        exit 1
    fi
}

function test_t() {
    reset
    sysak -g cpuirq -c 0 -i 3 -t > $temp_log 2>&1
    times=`cat $temp_log |grep "the top interrups" | wc -l`
    if test $times -ne 0
    then
        echo "Test -t success"
    else
        echo "Test -t failed"
        exit 1
    fi
}

function test_b() {
    reset
    sysak -g cpuirq -c 0 -b > $temp_log 2>&1
    times=`cat $temp_log |grep "show irq bind on" | wc -l`
    if test $times -ne 0
    then
        echo "Test -b success"
    else
        echo "Test -b failed"
        exit 1
    fi
}

function main()
{
    test_h
    test_c
    test_i
    test_t
    test_b
    reset
}

main