#!/bin/sh

temp_log_path="ossre_client.log"

function clean() {
    pkill ossre_client
    rm $temp_log_path
}

function handle_failed() {
    echo "Test ossre_client failed." 
    clean
    exit 1
}

function test_help() {
    sysak ossre_client --help > $temp_log_path 2>&1 && cat $temp_log_path | grep "usage: ossre.py" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test ossre_client --help success."
    fi
}

function test_all() {
    sysak ossre_client -d > $temp_log_path 2>&1 && cat $temp_log_path | grep "Traceback (most recent call last):" > /dev/null
    if test $? -ne 0
    then
        echo "Test ossre_client -d success."
    else
        handle_failed
    fi
}

function main() {
    test_help
    test_all
    clean
}

main
