#!/bin/sh

# sysak softirq: calculate softirq speed.It is used by tool loadtask.If you want use,please follow the steps below:
#          1.run command 'softirq -s sourcefile' to output initial value to sourcefile
#          2.sleep one second
#          3.run command 'softirq -s sourcefile -r resultfile' to output result to resultfile
# options: -h, help information
#          -s sourcefile, output initial value to sourcefile or get intial value from sourcefile
#          -r resultfile, output result to resultfile

temp_log_path="softirq.log"
temp_source_path="source.log"
temp_result_path="result.log"

function clean() {
    rm $temp_log_path
    rm $temp_source_path
    rm $temp_result_path
}

function handle_failed() {
    echo "Test softirq failed." 
    clean
    exit 1
}

function test_help() {
    sysak softirq --help > $temp_log_path 2>&1 && cat $temp_log_path | grep "sysak softirq:" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test softirq --help success."
    fi
}

function test_source() {
    sysak softirq -s $temp_source_path && cat $temp_source_path | grep "RCU:" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test softirq -s success."
    fi
}

function test_result() {
    sysak softirq -s $temp_source_path -r $temp_result_path && cat $temp_result_path | grep "RCU:" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test softirq -s sourcefile -r resultfile  success."
    fi
}


function main() {
    test_help
    test_source
    sleep 1
    test_result
    clean
}

main
