#!/bin/sh

#Usage: sysak reclaimhung [options]
#Options:
#    --time/-t     specify the monitor period(s), default=5000s
#    --help/-h     help info

temp_log_path="reclaimhung_tmp.log"

function clean() {
    rm $temp_log_path
}

function handle_failed() {
    echo "Test reclaimhung failed." 
    clean
    exit 1
}

function test_help() {
    sysak -g reclaimhung -h > $temp_log_path 2>&1 && cat $temp_log_path | grep "Usage: sysak reclaimhung" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test reclaimhung helpinfo success."
    fi
}

function test_reclaimhung() {
    sysak reclaimhung -t 10 > $temp_log_path 2>&1 && cat $temp_log_path | grep -E "Reclaim|Compaction|Cgroup Reclaim" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test reclaimhung -t 10 success."
    fi
}

function main() {
    test_help
    test_reclaimhung
    clean
}

main
