#!/bin/sh

temp_log_path="sar_tmp.log"

function handle_failed() {
    echo "Test sar failed." 
    clean
    exit 1
}

function clean() {
    rm $temp_log_path
}

function test_help() {
    sysak sar -h > $temp_log_path 2>&1 && cat $temp_log_path 
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar helpinfo success."
    fi
}

function test_cpu() {
    sysak sar --cpu > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar cpu success."
    fi
}


function test_mem() {
    sysak sar --mem > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar mem success."
    fi
}

function test_load() {
    sysak sar --load > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar load success."
    fi
}

function test_traffic() {
    sysak sar --traffic > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar traffic success."
    fi
}

function test_tcp() {
    sysak sar --tcp > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar tcp success."
    fi
}


function test_udp() {
    sysak sar --udp > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar udp success."
    fi
}

function test_io() {
    sysak sar --io > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test sar io success."
    fi
}

function test_partition() {
    sysak sar --partition > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        echo "Test sar partition failed."
    else
        echo "Test sar partition success."
    fi
}


function test_pcsw() {
    sysak sar --pcsw > $temp_log_path 2>&1 && cat $temp_log_path
    if test $? -ne 0
    then
        echo "Test sar pcsw failed."
    else
        echo "Test sar pcsw success."
    fi
}

function main() {
    test_help
    test_cpu
    test_mem
    test_load
    test_traffic
    test_tcp
    test_udp
    test_io
    test_partition
    test_pcsw
    clean
}

main
