#!/bin/bash

log_path="unity_test.log"

function clean() {
    systemctl stop sysak
    rm $log_path
}

function handle_failed() {
    echo "Test unity_test failed."
    clean
    exit 1
}

function check_metrics() {
    result=$(curl  http://127.0.0.1:8400/metrics)
    if echo "$result" | grep -Pzq '^#\ HELP.*\n#\ TYPE.*\n#\ HELP.*\n#\ TYPE'
    then
        handle_failed
    fi
}

function check_fail() {
    check_running=`cat $log_path | grep "Active: active (running)"  | wc -l`
    if (test $check_running -ne 1)
    then
      handle_failed
    fi
}

function test_start() {
    systemctl start sysak
    sleep 10
    systemctl status sysak > $log_path 2>&1 &
    sleep 1
    check_fail
    check_metrics

}

function main()
{
    test_start
    clean
    echo "Test unity_test success"
}

main
