#!/bin/sh

#shmem: shmem leak check tool
#Usage: shmem <option> [<args>]
#  -h                 help information
#  -t                 specify how long to run, default=5s
#  -l                 specify the check task numbers, default=10
#example:
#shmem.py -t 5 -l 20
temp_log_path="taskcache_tmp.info"

function clean() {
    rm $temp_log_path
}

function handle_failed() {
    echo "Test taskcache failed." 
    clean
    exit 1
}

function test_help() {
    sysak taskcache -h > $temp_log_path 2>&1 && cat $temp_log_path | grep "Usage: shmem" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test taskcache helpinfo success."
    fi
}

function test_task() {
    sysak taskcache -t 10 -l 20 > $temp_log_path 2>&1 && cat $temp_log_path | grep -E "old cache size|current cache size|pname" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test taskcache success."
    fi
}

function main() {
    test_help
    test_task
    clean
}

main
