#!/bin/sh

#shmem: shmem leak check tool
#Usage: shmem <option> [<args>]
#  -h                 help information
#  -t                 specify how long to run, default=5s
#  -l                 specify the check task numbers, default=10
#example:
#shmem.py -t 5 -l 20
temp_log_path="taskmem_tmp.info"

function clean() {
    rm $temp_log_path
}

function handle_failed() {
    echo "Test taskmem failed." 
    clean
    exit 1
}

function test_help() {
    sysak taskmem -h > $temp_log_path 2>&1 && cat $temp_log_path | grep "Usage: taskmem" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test taskmem helpinfo success."
    fi
}

function test_cache() {
    sysak taskmem -p 1 > $temp_log_path 2>&1 && cat $temp_log_path | grep -E "Rss|Vm" > /dev/null
    if test $? -ne 0
    then
        handle_failed
    else
        echo "Test task meminfo success."
    fi
}

function main() {
    test_help
    test_task
    clean
}

main
