#!/bin/sh

log_path="surftrace.log"

function clean() {
    rm $log_path
}

function handle_failed() {
    echo "Test sysak surftrace failed."
    clean
    exit 1
}

function test_h() {
    clean
    sysak surftrace -h > $log_path 2>&1
    check_h=`cat $log_path | grep "USAGE" | wc -l`
    if (test $check_h -ne 0)
    then
      echo "test sysak surftrace -h success"
    else
      echo "test sysak surftrace -h failed"
      handle_failed
    fi
}

function test_surftrace() {
    clean
    sysak surftrace 'p _do_fork' > $log_path 2>&1
    check=`cat $log_path | grep "error" | wc -l`
    if (test $check -ne 0)
    then
      echo "test sysak surftrace _do_fork failed"
      handle_failed
    else
      echo "test sysak surftrace _do_fork success"
    fi
}

function main() {
    test_h
    test_surftrace
    clean
    echo "surftrace test success"
}

main